/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables;


import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Indexes;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Keys;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.records.InvoiceAccantonamentoRecord;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class InvoiceAccantonamento extends TableImpl<InvoiceAccantonamentoRecord> {

    private static final long serialVersionUID = -1127502666;

    /**
     * The reference instance of <code>INVOICE_ACCANTONAMENTO</code>
     */
    public static final InvoiceAccantonamento INVOICE_ACCANTONAMENTO = new InvoiceAccantonamento();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<InvoiceAccantonamentoRecord> getRecordType() {
        return InvoiceAccantonamentoRecord.class;
    }

    /**
     * The column <code>INVOICE_ACCANTONAMENTO.ID_INVOICE_ACCANTONAMENTO</code>.
     */
    public final TableField<InvoiceAccantonamentoRecord, Integer> ID_INVOICE_ACCANTONAMENTO = createField("ID_INVOICE_ACCANTONAMENTO", org.jooq.impl.SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>INVOICE_ACCANTONAMENTO.ID_INVOICE</code>.
     */
    public final TableField<InvoiceAccantonamentoRecord, Integer> ID_INVOICE = createField("ID_INVOICE", org.jooq.impl.SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>INVOICE_ACCANTONAMENTO.NOTE</code>.
     */
    public final TableField<InvoiceAccantonamentoRecord, String> NOTE = createField("NOTE", org.jooq.impl.SQLDataType.VARCHAR(512), this, "");

    /**
     * The column <code>INVOICE_ACCANTONAMENTO.PERCENTUALE</code>.
     */
    public final TableField<InvoiceAccantonamentoRecord, BigDecimal> PERCENTUALE = createField("PERCENTUALE", org.jooq.impl.SQLDataType.DECIMAL(11, 2).nullable(false), this, "");

    /**
     * The column <code>INVOICE_ACCANTONAMENTO.DATA_INSERIMENTO</code>.
     */
    public final TableField<InvoiceAccantonamentoRecord, Timestamp> DATA_INSERIMENTO = createField("DATA_INSERIMENTO", org.jooq.impl.SQLDataType.TIMESTAMP.nullable(false).defaultValue(org.jooq.impl.DSL.field("CURRENT_TIMESTAMP", org.jooq.impl.SQLDataType.TIMESTAMP)), this, "");

    /**
     * The column <code>INVOICE_ACCANTONAMENTO.DATA_FINE_VALIDITA</code>.
     */
    public final TableField<InvoiceAccantonamentoRecord, Timestamp> DATA_FINE_VALIDITA = createField("DATA_FINE_VALIDITA", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>INVOICE_ACCANTONAMENTO.UTENTE</code>.
     */
    public final TableField<InvoiceAccantonamentoRecord, String> UTENTE = createField("UTENTE", org.jooq.impl.SQLDataType.VARCHAR(32), this, "");

    /**
     * The column <code>INVOICE_ACCANTONAMENTO.IMPORTO_ACCANTONATO</code>.
     */
    public final TableField<InvoiceAccantonamentoRecord, BigDecimal> IMPORTO_ACCANTONATO = createField("IMPORTO_ACCANTONATO", org.jooq.impl.SQLDataType.DECIMAL(34, 20).nullable(false), this, "");

    /**
     * The column <code>INVOICE_ACCANTONAMENTO.IMPORTO_ACCANTONATO_UTILIZZABILE</code>.
     */
    public final TableField<InvoiceAccantonamentoRecord, BigDecimal> IMPORTO_ACCANTONATO_UTILIZZABILE = createField("IMPORTO_ACCANTONATO_UTILIZZABILE", org.jooq.impl.SQLDataType.DECIMAL(12, 2), this, "");

    /**
     * Create a <code>INVOICE_ACCANTONAMENTO</code> table reference
     */
    public InvoiceAccantonamento() {
        this(DSL.name("INVOICE_ACCANTONAMENTO"), null);
    }

    /**
     * Create an aliased <code>INVOICE_ACCANTONAMENTO</code> table reference
     */
    public InvoiceAccantonamento(String alias) {
        this(DSL.name(alias), INVOICE_ACCANTONAMENTO);
    }

    /**
     * Create an aliased <code>INVOICE_ACCANTONAMENTO</code> table reference
     */
    public InvoiceAccantonamento(Name alias) {
        this(alias, INVOICE_ACCANTONAMENTO);
    }

    private InvoiceAccantonamento(Name alias, Table<InvoiceAccantonamentoRecord> aliased) {
        this(alias, aliased, null);
    }

    private InvoiceAccantonamento(Name alias, Table<InvoiceAccantonamentoRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> InvoiceAccantonamento(Table<O> child, ForeignKey<O, InvoiceAccantonamentoRecord> key) {
        super(child, key, INVOICE_ACCANTONAMENTO);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.INVOICE_ACCANTONAMENTO_FK_INVOICE_ACCANTONAMENTO_INVOICE_ID, Indexes.INVOICE_ACCANTONAMENTO_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<InvoiceAccantonamentoRecord, Integer> getIdentity() {
        return Keys.IDENTITY_INVOICE_ACCANTONAMENTO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<InvoiceAccantonamentoRecord> getPrimaryKey() {
        return Keys.KEY_INVOICE_ACCANTONAMENTO_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<InvoiceAccantonamentoRecord>> getKeys() {
        return Arrays.<UniqueKey<InvoiceAccantonamentoRecord>>asList(Keys.KEY_INVOICE_ACCANTONAMENTO_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<InvoiceAccantonamentoRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<InvoiceAccantonamentoRecord, ?>>asList(Keys.FK_INVOICE_ACCANTONAMENTO_INVOICE_ID);
    }

    public Invoice invoice() {
        return new Invoice(this, Keys.FK_INVOICE_ACCANTONAMENTO_INVOICE_ID);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceAccantonamento as(String alias) {
        return new InvoiceAccantonamento(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceAccantonamento as(Name alias) {
        return new InvoiceAccantonamento(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public InvoiceAccantonamento rename(String name) {
        return new InvoiceAccantonamento(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public InvoiceAccantonamento rename(Name name) {
        return new InvoiceAccantonamento(name, null);
    }
}
